;スプライトプラグイン

[loadcss file="./data/others/plugin/sprite/sprite.css"]

;[sprite]タグを追加する
[macro name="sprite"]
	[iscript]
		if(mp.name == "" || mp.name == undefined){
			tf.sprite_plugin_name = "spriteImg," + mp.sprite;
		}else{
			tf.sprite_plugin_name = "spriteImg," + mp.sprite + "," + mp.name;
		}
	[endscript]
	
	[image name="&tf.sprite_plugin_name" storage="none.png" folder="others/plugin/sprite" layer="&mp.layer" page="&mp.page" left="&mp.left" top="&mp.top" x="&mp.x" y="&mp.y" width="&mp.width" height="&mp.height" zindex="&mp.zindex" pos="&mp.pos"]
	
	[iscript]
		// sprite	クラス名
		// folder	スプライト画像のあるフォルダ（デフォルトはimage）
		// storage	スプライト画像名
		// width	1コマの横幅
		// height	1コマの縦幅
		// coma		コマ数
		// repeat	繰り返し
		// time		秒数
		// allwidth	スプライト画像全体の横幅
		// scaleX	
		
	$(function(){
		// spriteによるクラス名設定
		var name	= "";
		if(mp.sprite == "" || mp.sprite == undefined){
			alert("spriteタグにはspriteパラメータが必須です。");
		}else{
			name	= "." + mp.sprite;
		}
		
		// folder設定
		var forder	= "";
		if(mp.folder == "" || mp.folder == undefined){
			folder	= "image";
		}else{
			folder	= mp.folder;
		}
		
		// storageがあるならbackground-image値設定
		if(mp.storage != "" && mp.storage != undefined){
			var  bgimg	= "url(data/" + folder + "/" + mp.storage + ")";
			$(name).css({"background-image":bgimg});
		}
		
		// widthがあるならwidth値設定
		var width	= 60;
		if(mp.width != "" && mp.width != undefined){
			width	= mp.width;
			$(name).css({"width":mp.width});
		}
		
		// heightがあるならpadding-top値設定
		if(mp.height != "" && mp.height != undefined){
			$(name).css({"padding-top":mp.height+"px"});
		}
		
		// comaがあるならanimation-timing-function設定
		if(mp.coma != "" && mp.coma != undefined){
			$(name).css({"animation-timing-function":"steps(" + (mp.coma-1) + ", start)"});
			$(name).css({"-webkit-animation-timing-function":"steps(" + (mp.coma-1) + ", start)"});
			$(name).css({"-moz-animation-timing-function":"steps(" + (mp.coma-1) + ", start)"});
			$(name).css({"-o-animation-timing-function":"steps(" + (mp.coma-1) + ", start)"});
		}
		
		// repeatがあるならanimation-iteration-count設定
		if(mp.repeat != "" && mp.repeat != undefined){
			$(name).css({"animation-iteration-count":mp.repeat});
			$(name).css({"-webkit-animation-iteration-count":mp.repeat});
			$(name).css({"-moz-animation-iteration-count":mp.repeat});
			$(name).css({"-o-animation-iteration-count":mp.repeat});
		}
		
		// timeがあるならanimation-duration設定
		if(mp.time != "" && mp.time != undefined){
			$(name).css({"animation-duration":mp.time + "s"});
			$(name).css({"-webkit-animation-duration":mp.time + "s"});
			$(name).css({"-moz-animation-duration":mp.time + "s"});
			$(name).css({"-o-animation-duration":mp.time + "s"});
		}
		
		// allwidth設定
		var allwidth	= 300;
		if(mp.allwidth != "" && mp.allwidth != undefined){
			allwidth	= mp.allwidth;
		}
		
		// keyframe設定
		var keyframe	= "sprite" + allwidth + "x" + width;
		$(name).css({"animation-name":keyframe});
		$(name).css({"-webkit-animation-name":keyframe});
		$(name).css({"-moz-animation-name":keyframe});
		$(name).css({"-o-animation-name":keyframe});
		
		// scaleXなどがあるならtransform設定
		if(mp.scaleX != "" || mp.scaleY != "" || mp.rotate != "" || mp.skewX != "" || mp.skewY != ""){
			var sX	= 1;
			if(mp.scaleX != "" && mp.scaleX != undefined){
				sX	= mp.scaleX;
			}
			var sY	= 1;
			if(mp.scaleY != "" && mp.scaleY != undefined){
				sY	= mp.scaleY;
			}
			var r	= 0;
			if(mp.rotate != "" && mp.rotate != undefined){
				r	= mp.rotate;
			}
			var skX	= 0;
			if(mp.skewX != "" && mp.skewX != undefined){
				skX	= mp.skewX;
			}
			var skY	= 0;
			if(mp.skewY != "" && mp.skewY != undefined){
				skY	= mp.skewY;
			}
			
			$(name).css({"transform":"scaleX(" + sX + ") scaleY(" + sY + ") rotate(" + r + "deg) skewX(" + skX + "deg) skewY(" + skY + "deg)"});
		}
		
		// CSS入力用のやつ作る
		if($.find("#sprite-anime").length === 0){
			$("<style id='sprite-anime'></style>").appendTo("head");
		}
		
		// キーフレームアニメがなければ作る
		var intest	= $("#sprite-anime").html();
		if(intest.indexOf(keyframe) == -1){
			var tag	= keyframe + " { 0% {background-position: 0 0;} 100% {background-position: " + ((allwidth - width)*(-1)) + "px 0;} } ";
			var tag1	= "@keyframes " + tag;
			var tag2	= "@-webkit-keyframes " + tag;
			var tag3	= "@-moz-keyframes " + tag;
			var tag4	= "@-o-keyframes " + tag;
			
			$("#sprite-anime").html($("#sprite-anime").html() + tag1 + tag2 + tag3 + tag4);
		}
		
	});
	[endscript]
[endmacro]


@return